/* 
   $Id: IMlib.h,v 1.5 2001/06/15 12:05:09 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef NNM_IMLIB_H
#define NNM_IMLIB_H

#include <stdio.h>
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "IMProto.h"

// IMDataType.c
int	XimSetImValue( int idx, XIMATTRIBUTE *ximatr );
int	XimPcktGetXIMATTRIBUTE( unsigned char *pckt, 
				XIMATTRIBUTE *ximattribute );
int	XimPcktSetXIMATTRIBUTE( unsigned char *pckt,
				int attrID);
int	XimPcktSetXICATTRIBUTE( unsigned char *pckt,
				XICATTRIBUTE *xicattribute );
int	XimSetXICATTRIBUTE( int icID,
			    XICATTRIBUTE *xicatr );
int	XimGetXICATTRIBUTE( int icID, int atrID, 
			    XICATTRIBUTE *xicatr );
int	XimConvertToCompoundText( Display *dpy,
				  XICCEncodingStyle style,
				  char	*str, XTextProperty *ct );
int	XimConvertXEventToxEvent( XEvent *ev, xEvent *sEv );

// IMPacket.c
unsigned short	XimPcktGetCARD16( unsigned char *pckt );
unsigned long	XimPcktGetCARD32( unsigned char *pckt );
int	XimPcktSetCARD16( unsigned char *buf, int data );
int	XimPcktSetCARD32( unsigned char *buf, int data );
int	XimPcktGetSTRING( unsigned char *pckt, XIMSTRING *ximstring );
int	XimPcktSetSTRING( unsigned char *pckt, XIMSTRING *ximstring );
int	XimPcktGetSTR( unsigned char *pckt, XIMSTR *ximstr );
int	XimPcktSetSTR( unsigned char *pckt, XIMSTR *ximstr );
int	XimPcktGetXIMATTR( unsigned char *pckt, XIMATTR *ximattr );
int	XimPcktSetXIMATTR( unsigned char *pckt, XIMATTR *ximattr );
int	XimPcktGetXICATTR( unsigned char *pckt, XICATTR *xicattr );
int	XimPcktSetXICATTR( unsigned char *pckt, XICATTR *xicattr );
int	XimPcktGetXIMTRIGGERKEY( unsigned char *pckt, 
				 XIMTRIGGERKEY *ximtrigkey );
int	XimPcktSetXIMTRIGGERKEY( unsigned char *pckt, 
				 XIMTRIGGERKEY *ximtrigkey );
int	XimPcktGetENCODINGINFO( unsigned char *pckt, 
				XIMENCODINGINFO *ximencodinginfo );
int	XimPcktSetENCODINGINFO( unsigned char *pckt, 
				XIMENCODINGINFO *ximencodinginfo );
int	XimPcktGetXIMSTRCONVTEXT( unsigned char *pckt,
				  XIMSTRCONVTEXT *ximstrconvtext );
int	XimPcktSetXIMSTRCONVTEXT( unsigned char *pckt,
				  XIMSTRCONVTEXT *ximstrconvtext );
int	XimPcktGetXIMERROR( unsigned char *pckt, XIMERROR *ximerror );
int	XimPcktGetXIM_OPEN_REPLY( unsigned char *pckt, int *imID,
				  XIMATTR *ximattr, XICATTR *xicattr );
int	XimPcktGetXIM_REGISTER_TRIGGERKEYS( unsigned char *pckt, int *imID,
					    XIMTRIGGERKEY *onkey, 
					    XIMTRIGGERKEY *offkey );
int	XimPcktGetXIM_ENCODING_NEGOTIATION( unsigned char *pckt, int *imID,
					    XIMSTR **ximstrp, int *ximstrlen,
					    XIMENCODINGINFO **ximencodinginfop, 
					    int *ximencodinginfolen );
int	XimPcktGetXICATTRIBUTE( unsigned char *pckt,
				XICATTRIBUTE *xicatr );
int	XimPcktGetXIM_QUERY_EXTENSION( unsigned char *pckt, int *imID );


// IMProto.c
int	SendXIMPacket( Display *dpy, Window sender, 
		       Window serv_w, unsigned char *pckt, int len );
void	CommWidgetEvHandler( Widget w, XtPointer clo, 
			     XEvent *ev, Boolean *ctd );

// IMRecieve.c
void	SendXIM_ERROR(Window sender, Widget server_w, int imID, int icID,
  int mask, int ecode);
void	RecieveXIM_CONNECT( unsigned char *packet, int len, 
			    Window sender, Widget server_w );
void	RecieveXIM_DISCONNECT( unsigned char *packet, int len, 
			       Window sender, Widget server_w );
void	RecieveXIM_OPEN( unsigned char *packet, int len, 
			 Window sender, Widget server_w );
void	RecieveXIM_QUERY_EXTENSION( unsigned char *packet, int len, 
				    Window sender, Widget server_w );
void	RecieveXIM_ENCODING_NEGOTIATION( unsigned char *packet, int len,
					 Window sender, Widget server_w );
void	RecieveXIM_SET_IM_VALUES( unsigned char *packet, int len,
				  Window sender, Widget server_w );
void	RecieveXIM_GET_IM_VALUES( unsigned char *packet, int len,
				  Window sender, Widget server_w );
void	RecieveXIM_CREATE_IC( unsigned char *packet, int len,
			      Window sender, Widget server_w );
void	RecieveXIM_SET_IC_VALUES( unsigned char *packet, int len,
				  Window sender, Widget server_w );
void	RecieveXIM_GET_IC_VALUES( unsigned char *packet, int len,
				  Window sender, Widget server_w );
void	RecieveXIM_TRIGGER_NOTIFY( unsigned char *packet, int len,
				   Window sender, Widget server_w );
void	RecieveXIM_FORWARD_EVENT( unsigned char *packet, int len,
				  Window sender, Widget server_w );
void	RecieveXIM_SYNC( unsigned char *packet, int len,
			 Window sender, Widget server_w );
void	RecieveXIM_SET_IC_FOCUS( unsigned char *packet, int len,
				 Window sender, Widget server_w );
void	RecieveXIM_CLOSE( unsigned char *packet, int len,
			  Window sender, Widget server_w );
void	RecieveXIM_DESTROY_IC( unsigned char *packet, int len,
			       Window sender, Widget server_w );
void	RecieveXIM_UNSET_IC_FOCUS( unsigned char *packet, int len,
				   Window sender, Widget server_w );
void	XimSendString( char *str );
void	XimSendKey(unsigned int code);

// PcktCreate.c
int	XimGetICidx( int icID );
int	XimGetIMidx( int imID );
int	XimCreateIC( int imidx);
int	XimDestroyIC( int imID, int icID );
void	XimDestroyAllIC( int imID);
int	CreatePacketXIM_OPEN_REPLY( unsigned char *buf, Window sender );
int	CreatePacketXIM_REGISTER_TRIGGERKEYS( unsigned char *buf, 
					      Window sender );
int	CreatePacketXIM_QUERY_EXTENSION_REPLY( unsigned char *buf, 
					       Window sender, int imID );
int	CreatePacketXIM_ENCODING_NEGOTIATION_REPLY( unsigned char *buf, 
						    Window sender,
						    int imID, int idx );
int	CreatePacketXIM_CLOSE_REPLY( unsigned char *buf, Window sender, 
				     int imID );
int	CreatePacketXIM_SET_IM_VALUES_REPLY( unsigned char *buf,
					     Window sender,
					     int imID );
int	CreatePacketXIM_GET_IM_VALUES_REPLY( unsigned char *buf, Window sender,
					     int idx, int *attrID, int attrlen );
int	CreatePacketXIM_CREATE_IC_REPLY( unsigned char *buf, Window sender,
					 int imID, int icID );
int	CreatePacketXIM_SET_IC_VALUES_REPLY( unsigned char *buf, Window sender,
					     int imID, int icID );
int	CreatePacketXIM_GET_IC_VALUES_REPLY( unsigned char *buf, Window sender,
					     int imID, int icID,
					     int *xicattrID, 
					     int num_xicattr );
int	CreatePacketXIM_TRIGGER_NOTIFY_REPLY( unsigned char *buf,
					      Window sender, 
					      int imID, int icID );
int	CreatePacketXIM_SET_EVENT_MASK( unsigned char *buf, Window sender,
					int imID, int icID,
					unsigned long fevmask,
					unsigned long sevmask );
int	CreatePacketXIM_SYNC_REPLY( unsigned char *buf, Window sender,
				    int	imID, int icID );
int	CreatePacketXIM_FORWARD_EVENT( unsigned char *buf, Window sender,
				       int imID, int icID, unsigned long flag,
				       int serial, XEvent *ev );
int	CreatePacketXIM_COMMIT( unsigned char *buf, Window sender,
				int imID, int icID, unsigned long flag,
				unsigned char *commit_str, int len );
int	CreatePacketXIM_ERROR( unsigned char *buf, Window sender,
			       int imID, int icID, int mask, int ecode );
int	CreatePacketXIM_DESTROY_IC_REPLY( unsigned char *buf, Window sender,
					  int imID, int icID );

// Preconnect.c
int	SetServerProperty( Widget w );
void	TopLevelEvHandler( Widget w, XtPointer clo,
			   XEvent *ev, Boolean *ctd );
void	DisposeIMConnection( Window client_w );
void	IMHookXError(void);
int	IMUnhookXError(void);

#endif
