/* 
   $Id: nnmWnn.c,v 1.4 2001/05/14 06:42:12 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "config.h"
#ifdef WNN
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>

#include <wnn/wnnerror.h>

#include <X11/Intrinsic.h>

#include "nnmUI.h"

#ifndef WNNLIBDIR
#define "/usr/local/lib/wnn"
#endif
#define DEFAULT_WNNENVRC "/usr/local/lib/wnn/ja_JP/wnnenvrc"

struct wnn_buf *wnnbuf;

void uch2wch(uch, wch)
     unsigned char *uch;
     wchar *wch;
{
  int x;

  while(*uch){
    x = *uch++;
    if(x & 0x80) x = (x << 8) | *uch++;
    *wch++ = x;
  }

  *wch = 0;
}

void wch2uch(wch, uch)
     wchar *wch;
     unsigned char *uch;
{
  int x;

  while(*wch){
    x = *wch++;
    if((x >> 8) > 0) *uch++ = (x >> 8);
    *uch++ = (x & 0xff);
  }

  *uch = 0;
}

int wchstrlen(str)
     wchar *str;
{
  int i = 0;
  while(*str) str++,i++;
  return i;
}

int NnmOpenJserver( w )
     Widget w;
{
  char *rcfile  = NULL;
  char *jserver = NULL;
  
  rcfile = (char *)getenv("WNNENVRC");
  if(rcfile == NULL){
    NnmGetResource(w, (String)"wnnenvrc", (XtArgVal *)&rcfile);
#ifdef DEBUG_PRINT
    fprintf(stderr,"wnnenvrc: %s\n", rcfile);
#endif

    if(rcfile == NULL)
      rcfile = WNNLIBDIR "/ja_JP/wnnenvrc";
  }

  jserver = (char *)getenv("JSERVER");
  if(jserver == NULL){
    NnmGetResource(w, (String) "jserver", (XtArgVal *) &jserver);
#ifdef DEBUG_PRINT
    fprintf(stderr,"jserver: %s\n", jserver);
#endif

    if (jserver == NULL)
      jserver = "localhost";
  }

  wnnbuf = jl_open(getpwuid(getuid()), jserver, rcfile, WNN_CREATE, NULL, 30);

  if(!wnnbuf){    
    fprintf(stderr,"can't open jserver\n");
    return -1;
  }

  if(!jl_isconnect(wnnbuf)){
    fprintf(stderr,"not connecting jserver\n");
    return -1;
  }

  return 0;
}

void NnmGetYomi(yomi)
     wchar *yomi;
{
  jl_get_yomi(wnnbuf, 0, -1, yomi);
}

int NnmZenkouhoSuu()
{
  return jl_zenkouho_suu(wnnbuf);
}

void NnmGetZenkouho(kouho, kanji)
     int   kouho;
     wchar *kanji;
{
    jl_get_zenkouho_kanji(wnnbuf, kouho, kanji);
}

int NnmTanHenkan(yomi, kanji)
     wchar *yomi;
     wchar *kanji;
{
  int i;

  i =  jl_tan_conv(wnnbuf, yomi, 0, -1, WNN_NO_USE, WNN_SHO);
#ifdef DEBUG_PRINT
  fprintf(stderr,"bun_suu: %d\n", i);
#endif

  jl_zenkouho(wnnbuf, 0, WNN_USE_MAE, WNN_UNIQ_KNJ);
  i = jl_zenkouho_suu(wnnbuf);
#ifdef DEBUG_PRINT
  fprintf(stderr,"zenkouho_suu: %d\n", i);
#endif

  jl_get_zenkouho_kanji(wnnbuf, 0, kanji);
  return i;
}

#endif /* WNN */

